Main Page Namespace List Class Hierarchy Compound List File List Namespace Members Compound Members Related Pages

# aka2::choice< T, L > Class Template Reference

template to define aka:choice leaf class. More...

`#include <choice.h>`

Inheritance diagram for aka2::choice< T, L >:

[legend]
Collaboration diagram for aka2::choice< T, L >:

[legend]
List of all members.

## Public Methods
template<class IL> void | item (const std::string &tagname, const IL &il, int minOccurs=1, int maxOccurs=1, bool emptiable=false)
void | any (const std::string &tagname, const std::string &ns_list="##any")
void | any (const std::string &tagname, int minOccurs, int maxOccurs, const std::string &ns_list="##any")
void | any (const std::string &tagname, int minOccurs, int maxOccurs, bool emptiable, const std::string &ns_list)
template<class IL> void | fixed_item (const std::string &tagname, const std::string &fixed_value, const IL &il)
template<class IL> void | fixed_array (const std::string &tagname, const std::string &fixed_value, const IL &il, int minOccurs, int maxOccurs, bool emptiable=false)
## Static Public Methods
void | occurrence (int minOccurs, int maxOccurs, bool emptiable=false)

## Detailed Description

### template<class T, class L>
class aka2::choice< T, L >

template to define aka:choice leaf class.

Leaf classes for aka:choice are derived from this template class.
Users don't have to use this class directly.
Please use aka2::sequential_choice<> template for sequence containers, or aka2::associative_choice<> template for choice containers.

Parameters:

  T | value class type
  L | leaf class type

Definition at line 102 of file choice.h.

## Member Function Documentation

template<class T, class L>
void aka2::choice< T, L >::any | ( | const std::string & | tagname,
|  | int | minOccurs,
|  | int | maxOccurs,
|  | bool | emptiable,
|  | const std::string & | ns_list
| ) | `[inline]`

  | define array of wildcard (aka2::any_array, xs:anyType[] in XML Schema) child elements. Parameters:
  tagname | tag name
  minOccurs | minOccurs
  maxOccurs | maxOccurs
  ns_list | namespace list. available values are "#any", "#other:target_namespace_uri", "#local" or namespace uri list.
  emptiable | true if array could be empty even minOccurs is not zero.
Definition at line 237 of file choice.h.

template<class T, class L>
void aka2::choice< T, L >::any | ( | const std::string & | tagname,
|  | int | minOccurs,
|  | int | maxOccurs,
|  | const std::string & | ns_list = "##any"
| ) | `[inline]`

  | define array of wildcard (aka2::any_array, xs:anyType[] in XML Schema) child elements. Parameters:
  tagname | tag name
  minOccurs | minOccurs
  maxOccurs | maxOccurs
  ns_list | namespace list. available values are "#any", "#other:target_namespace_uri", "#local" or namespace uri list.
Definition at line 220 of file choice.h. References aka2::choice< T, L >::any().

template<class T, class L>
void aka2::choice< T, L >::any | ( | const std::string & | tagname,
|  | const std::string & | ns_list = "##any"
| ) | `[inline]`

  | define wildcard (aka2::any, xs:anyType in XML Schema) child element. Parameters:
  tagname | tag name
  ns_list | namespace list. available values are "#any", "#other:target_namespace_uri", "#local" or namespace uri list.
Definition at line 197 of file choice.h. Referenced by aka2::choice< T, L >::any().

template<class T, class L>
template<class IL>
void aka2::choice< T, L >::fixed_array | ( | const std::string & | tagname,
|  | const std::string & | fixed_value,
|  | const IL & | il,
|  | int | minOccurs,
|  | int | maxOccurs,
|  | bool | emptiable = false
| ) | `[inline]`

  | define array of elements having fixed value. Parameters:
  tagname | tag name
  fixed_value | fixed value
  il | leaf class for fixed value class.
  minOccurs | minOccurs
  maxOccurs | maxOccurs
  emptiable | true if array could be empty even minOccurs is not zero.
Definition at line 285 of file choice.h.

template<class T, class L>
template<class IL>
void aka2::choice< T, L >::fixed_item | ( | const std::string & | tagname,
|  | const std::string & | fixed_value,
|  | const IL & | il
| ) | `[inline]`

  | define element having fixed value. Parameters:
  tagname | tag name
  fixed_value | fixed value
  il | leaf class for fixed value class.
Definition at line 258 of file choice.h.

template<class T, class L>
template<class IL>
void aka2::choice< T, L >::item | ( | const std::string & | tagname,
|  | const IL & | il,
|  | int | minOccurs = 1,
|  | int | maxOccurs = 1,
|  | bool | emptiable = false
| ) | `[inline]`

  | define item as an child element. Parameters:
  tagname | tag name
  il | leaf class of child element.
  minOccurs | minOccurs
  maxOccurs | maxOccurs
  emptiable | true if array could be empty even minOccurs is not zero.
Definition at line 163 of file choice.h.

template<class T, class L>
void aka2::choice< T, L >::occurrence | ( | int | minOccurs,
|  | int | maxOccurs,
|  | bool | emptiable = false
| ) | `[inline, static]`

  | define occurrence of aka:choice itself. Parameters:
  minOccurs | minOccurs
  maxOccurs | maxOccurs
  emptiable | true if array could be empty even minOccurs is not zero.
Definition at line 149 of file choice.h.

The documentation for this class was generated from the following file:

- choice.h